//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Algorithme Gntique : Problme du Voyageur de Commerce  (Vuibert)
//    v:0.1 10/09/2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package pvcag;

import java.awt.*;
import vabase.*;

/** Classe de gestion de vue, base graphique */
public class vuePvc extends Cvue {

  /** Pointeur sur l'algorithme */
  private Cag agPere;
  /** Taille du dessin de la ville */
  private float tailleVille=2;

  /** Constructeur par dfaut */
  public vuePvc(Cag ag) {
    super(Color.black, Color.blue, Cvue.REPRANISOTROPIC);
    agPere=ag;
    redimCadre(50,50);
    setTailleVille();
  }
  /** Constructeur avec fond */
  public vuePvc(Cag ag, Color c, Color f) {
    super(c, f, Cvue.REPRANISOTROPIC);
    agPere=ag;
    redimCadre(50,50);
    setTailleVille();
  }
  /** Affichage de toutes les villes */
  public void affVilles() {
    affVille(agPere.villes[0],true);
    for(int i=1;i<agPere.nbVilles;i++)
      affVille(agPere.villes[i],false);
  }
  /** Affichage d'une ville */
  public void affVille(Cville v, boolean premier) {
    if(premier)
      grBuff.setColor(Color.red);
    else
      grBuff.setColor(Color.black);
    grBuff.fillRect(
      lToRX(v.x-tailleVille),
      lToRY(v.y-tailleVille),
      lLongueurToRX(tailleVille*2),lLongueurToRY(tailleVille*2));
  }
  /** Affichage d'un parcours */
  public void affParcours(String parc, Color c) {
    grBuff.setColor(c);
    for(int i=0;i<parc.length()-1;i++)
      grBuff.drawLine(lToRX(agPere.villes[parc.charAt(i)].x),
                      lToRY(agPere.villes[parc.charAt(i)].y),
                      lToRX(agPere.villes[parc.charAt(i+1)].x),
                      lToRY(agPere.villes[parc.charAt(i+1)].y));
  }

  /** Fixe nouvelle taille */
  public void setNewTaille() {
    redimGrBuff();
    setTailleVille();
    peintFond();
    repaint();
  }
  /** Fixe les dimensions des villes */
  public void setTailleVille() {
    tailleVille=Math.min(lLargeur/350.0F, lHauteur/350.0F);
  }
  /** Peint le fond */
  public void peintFond() {
    effaceFond();
    Color colcrt=grBuff.getColor();
    grBuff.setColor(getBackground());
    grBuff.fillRect(lToRX(0.0F),lToRY(0.0F),lToRX(lLargeur),lToRY(lHauteur));
    grBuff.setColor(colcrt);
    grBuff.drawRect(0,lToRX(lLargeur),lToRY(lHauteur),0);
    affVilles();
  }
}

